 {  ࠡ  묨 䠩 ᮢ}
 {  ⠪ ᯮ짮 ᫨ 㦭 - 㯠}
 {  ⮤ LZW. ࠧ  魠   ࠧ}
 {஢ (TMT,VP,Delphi)   ஬ 䠩 (DOS/WIN) }
 {㯭  www.coolsoftteam.narod.ru}
 {:  类, cooler@tut.by, 2:450/164.5}
 
 {$I-}
 unit data2;
  interface
   const
    on=true;
    off=false;
   var
    size1,size2:longint;
    posled:array[0..64] of byte;
    datfile:file;
    encrypted,loaded:boolean;
    errorproc:procedure(code:integer);

    function checksum(var p;size:longint):word;
    procedure encrypt(var p;size:longint;code:word);
    function lzwpack(var sour,dest;size1:longint):longint;
    function lzwunpack(var sour,dest):longint;
    procedure opendatfile(name:string;filecode:word);
    procedure closedatfile;
    function getdata(n:byte;var p:pointer):longint;
    function findname(reqname:string):byte;

  implementation
  {$IFDEF DPMI}
   uses winapi,dpmi,sysutils;
  {$ENDIF}
   const
    idstr:string[12]='  ';
   type
    headertype=record
     id:array[1..10] of byte;
     count:byte;
     encrypted:boolean;
     size:longint;
    end;
    rectype=record
     start,size1,size2:longint;
     sum1,sum2:word;
     sort:byte;
     pack:boolean;
     name:string[13];
    end;
   var
    header:headertype;
    count:byte;
    dir:array[1..128] of rectype;
    buf:pointer;
    code:word;
    st:string[60];

   function packlzw(s1:word;o1:longint;
                    s2:word;o2:longint;
                    s3:word;o3:longint;
                    s:longint):longint; external; {$L lzw.obj}
   function unpacklzw(s1:word;o1:longint;
                      s2:word;o2:longint;
                      segt:word):longint; external; {$L lzw5.obj}
   const
    cc=256;
    eoi=257;
   type
    rec=record
     ch:byte;
     len:byte;
     prev:integer;
    end;
    mas=array[0..4099] of rec;
   var
    i,j:integer;
    tab:^mas;
    s,o,s2,o2,segt,ot:word;
  function lzwpack;
   label m;
   begin
    { initialize }
    for i:=0 to 255 do begin
     tab^[i].ch:=i;
     tab^[i].len:=1;
     tab^[i].prev:=-1;
    end;
    size2:=0;
    s:=seg(sour); s2:=seg(dest);
    o:=ofs(sour); o2:=ofs(dest);
    segt:=seg(tab^); ot:=ofs(tab^);
    { coding }
    lzwpack:=packlzw(segt,ot,s,o,s2,o2,size1);
   end;
  function checksum;
   var
    s,o:word;
    sum:word;
    l:longint;
   begin
    s:=seg(p);
    o:=ofs(p);
    asm
     mov ax,s
     mov es,ax
     db 66h; xor di,di
     add di,o
     xor bx,bx
     xor ax,ax
     db 66h; mov cx,word ptr size
@01: db 26h,67h,8ah,07h
     xor al,cl
     add bx,ax
     db 66h; inc di
     db 67h; loop @01
     mov sum,bx
    end;
    checksum:=sum;
   end;
  procedure encrypt;
   var
    s,o:word;
   begin
    s:=seg(p);
    o:=ofs(p);
    asm
     mov ax,s
     mov es,ax
     db 66h; xor di,di
     mov di,o
     mov bx,code
     db 66h; mov cx,word ptr size
@01: mov ax,19
     mul bx
     mov bx,ax
     xor al,ah
     db 26h,67h,8ah,17h
     xor dl,al
     db 26h,67h,88h,17h
     db 66h; inc di
     db 67h; loop @01
    end;
   end;
  function lzwunpack;
   var
    code,old,posit,adr:word;
    bpos:byte;
   begin
    for i:=0 to 255 do
    with tab^[i] do begin
     prev:=-1;
     len:=i;
     ch:=i;
    end;
    s:=seg(sour); o:=ofs(sour);
    s2:=seg(dest); o2:=ofs(dest); size2:=0;
    segt:=seg(tab^);
    lzwunpack:=unpacklzw(s,o,s2,o2,segt);
   end;
  procedure opendatfile;
   begin
    st:=name;
    if pos('.',st)=0 then st:=st+'.dat';
    assign(datfile,st);
    reset(datfile,1);
    if (ioresult<>0) or (filesize(datfile)<16) then
    if addr(errorproc)<>nil then errorproc(1) else
     begin
      writeln('訡 ⥭ 䠩 : ',st);
      writeln(' 㤠  䠩!'); halt;
     end;
    blockread(datfile,header,16);
    with header do
     if (id[1]<>148) or (id[2]<>128) or (filesize(datfile)<>size) then
     if addr(errorproc)<>nil then errorproc(2) else
     begin
      writeln('訡 ⥭ 䠩 : ',st);
      writeln(' ०!'); halt;
     end;
    count:=header.count;
    blockread(datfile,dir,count*32);
    encrypted:=header.encrypted;
    code:=filecode;
    loaded:=on;
   end;
  procedure closedatfile;
   begin
    close(datfile);
    loaded:=off;
   end;
  function getdata;
   begin
    if n>header.count then exit;
    with dir[n] do begin
     {$IFDEF DPMI}
     getmem(p,size2);
     seek(datfile,start);
     readfile(datfile,buf,size1);
     if encrypted then encrypt(buf^,size1,code);
     if checksum(buf^,size1)<>sum1 then
     if addr(errorproc)<>nil then errorproc(3) else begin
      writeln('訡 ⥭ 䠩 : ',st);
      writeln('   ०  ',n); halt;
     end;
     if pack then lzwunpack(buf^,p^) else move(buf^,p^,size1);
     if checksum(p^,size2)<>sum2 then
     if addr(errorproc)<>nil then errorproc(4) else begin
      writeln('訡  䠩 : ',st);
      writeln('訡 ᯠ  ',n); halt;
     end;
     freemem(buf);
     {$ELSE}
     getmem(p,size2+16);
     seek(datfile,start);
     getmem(buf,size1);
     blockread(datfile,buf^,size1);
     if encrypted then encrypt(buf^,size1,code);
     if checksum(buf^,size1)<>sum1 then
     if addr(errorproc)<>nil then errorproc(3) else begin
      writeln('訡 ⥭ 䠩 : ',st);
      writeln('   ०  ',n); halt;
     end;
     if pack then lzwunpack(buf^,p^) else move(buf^,p^,size1);
     if checksum(p^,size2)<>sum2 then
     if addr(errorproc)<>nil then errorproc(4) else begin
      writeln('訡  䠩 : ',st);
      writeln('訡 ᯠ  ',n); halt;
     end;
     freemem(buf,size1);
     {$ENDIF}
    end;
    getdata:=dir[n].size2;
   end;
  function findname;
   begin
    if not loaded then exit;
    for i:=1 to count do
     if pos(reqname,dir[i].name)>0 then begin
      findname:=i; exit; end;
    if addr(errorproc)<>nil then errorproc(6) else begin
     writeln('訡!  䠩 ',st,'      ',reqname);
     halt;
    end;
   end;
 begin
    errorproc:=nil;
  {$IFDEF DPMI}
    tab:=globalallocptr(2,65536+16);
    setsegmentlimit(seg(tab^),65536+16);
  {$ELSE}
   new(tab);
  {$ENDIF}
 end.
